package com.example.acer.agendita_mysql_c;

import android.app.ProgressDialog;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

import librerias.ConexionWeb;
import librerias.Datos;
import librerias.MiBaseDatos;
import librerias.Parametros;


public class CambiosFragment extends Fragment implements View.OnClickListener {
    Button btnCancelar, btnBuscar, btnModificar;
    EditText txtNombre, txtApellido, txtTelefono;
    MiBaseDatos baseDatos;
    String nombreModificar="",apellidoModificar="", telefonoModificar="";
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_cambios, container, false);
    }
    public void onStart(){
        super.onStart();
        txtNombre=(EditText)getView().findViewById(R.id.txtNombreCambios);
        txtApellido=(EditText)getView().findViewById(R.id.txtApellidoCambios);
        txtTelefono=(EditText)getView().findViewById(R.id.txtTelBuscarCambios);
        btnBuscar=(Button)getView().findViewById(R.id.btnBuscarCambios);
        btnCancelar=(Button)getView().findViewById(R.id.btnCancelarCambios);
        btnModificar=(Button)getView().findViewById(R.id.btnModificarCambios);
        btnCancelar.setOnClickListener(this);
        btnModificar.setOnClickListener(this);
        btnBuscar.setOnClickListener(this);
    }
    @Override
    public void onClick(View v) {
        if(v.getId()==R.id.btnCancelarCambios){
            cancelar();
        }else if(v.getId()==R.id.btnBuscarCambios){
            if(Parametros.conexion.equals("Local")){
                buscarLocal();
            }else if(Parametros.conexion.equals("Remoto")){
                buscarRemoto();
            }
        }else if (v.getId()==R.id.btnModificarCambios){
            if(Parametros.conexion.equals("Local")){
                modificar();
            }else if(Parametros.conexion.equals("Remoto")){
                modificaRemoto();
            }
        }
    }
    public void cancelar(){
        txtTelefono.setText("");
        txtApellido.setText("");
        txtNombre.setText("");
        nombreModificar="";
        apellidoModificar="";
        telefonoModificar="";
    }
    public void buscarRemoto(){
        if (txtTelefono.getText().toString().equals("")){
            Toast.makeText(getContext(), "Favor de Introducir un Telefono", Toast.LENGTH_SHORT).show();
        }else {
            ArrayList<String> valores = new ArrayList();
            String telefono = txtTelefono.getText().toString();
            valores.add(0, telefono);
            new TareaBuscarWeb(valores).execute();
        }
    }
    public void mostrarDatoRemoto(Datos dato){
        Log.d("NOmbre:",dato.getNombre());
        txtNombre.setText(dato.getNombre());
        txtApellido.setText(dato.getApellido());
        nombreModificar=dato.getNombre();
        apellidoModificar=dato.getApellido();
        telefonoModificar=dato.getTelefono();
    }
    public void buscarLocal() {
        String tel = txtTelefono.getText().toString();
        if (tel.equals("")) {
            Toast.makeText(getContext(), "Favor de introducir un Telefono", Toast.LENGTH_SHORT).show();
        } else {
            baseDatos = new MiBaseDatos(getContext());
            SQLiteDatabase sql = baseDatos.getReadableDatabase();
            String[] columnas = {
                    Parametros.campo_nombre,
                    Parametros.campo_apellido,
                    Parametros.campo_telefono};
            String consulta = "telefono='" + tel + "'";
            Cursor cursor = sql.query(Parametros.tabla_datos, columnas, consulta, null, null, null, null);

            if (cursor.getCount() != 0) {
                cursor.moveToFirst();
                txtNombre.setText(cursor.getString(cursor.getColumnIndex(Parametros.campo_nombre)));
                txtApellido.setText(cursor.getString(cursor.getColumnIndex(Parametros.campo_apellido)));
                nombreModificar=cursor.getString(cursor.getColumnIndex(Parametros.campo_nombre));
                apellidoModificar=cursor.getString(cursor.getColumnIndex(Parametros.campo_apellido));
                telefonoModificar=cursor.getString(cursor.getColumnIndex(Parametros.campo_telefono));

            }
            sql.close();
        }
    }
    public void modificar(){
        String nom=txtNombre.getText().toString();
        String ape=txtApellido.getText().toString();
        String tel=txtTelefono.getText().toString();
        if(nom.equals("")||ape.equals("")||tel.equals("")){
            Toast.makeText(getContext(), "Favor de no dejar ningun campo Vacio", Toast.LENGTH_SHORT).show();
        }else{
            baseDatos=new MiBaseDatos(getContext());
            SQLiteDatabase sql=baseDatos.getReadableDatabase();
            ContentValues valores=new ContentValues();
            valores.put(Parametros.campo_nombre,nom);
            valores.put(Parametros.campo_apellido,ape);
            valores.put(Parametros.campo_telefono,tel);
            String consulta=Parametros.campo_nombre+"='"+nombreModificar+"' and "+Parametros.campo_apellido+"='"+apellidoModificar
                        +"' and "+Parametros.campo_telefono+"='"+telefonoModificar+"'";
            Toast.makeText(getContext(), consulta, Toast.LENGTH_SHORT).show();
            sql.update(Parametros.tabla_datos,valores,consulta,null);
            sql.close();
            cancelar();
        }
    }
    public void modificaRemoto(){
        String nombre=txtNombre.getText().toString();
        String apellido=txtApellido.getText().toString();
        String telefono=txtTelefono.getText().toString();
        ArrayList<String> valores=new ArrayList();
        valores.add(nombre);
        valores.add(apellido);
        valores.add(telefono);
        valores.add(nombreModificar);
        valores.add(telefonoModificar);
        new TareaModificarWeb(valores).execute();
    }
    private class TareaBuscarWeb extends AsyncTask<Void, Void, String> {
        String URL = "http://"+Parametros.servidor+"/EjemploMysql/Buscar.php";
        // private JSONArray jsonDatos = null;
        ArrayList<String> valores;
        private JSONArray jsonDatos = null;
        Datos dato;
        private ProgressDialog nDialog;
        public TareaBuscarWeb(ArrayList<String> valores){
            nDialog = new ProgressDialog(getActivity());
            this.valores=valores;
        }
        @Override
        //accion principal
        protected String doInBackground(Void... voids) {

            ArrayList<String> keys = new ArrayList();
            ArrayList<String> valor = new ArrayList();
            keys.add(0, "telefono");valor.add(0, valores.get(0));
            ConexionWeb conexionWeb = new ConexionWeb();
            try {
                String jsonStr = conexionWeb.buscarDato(URL, conexionWeb.armarGET(keys,valor));

                JSONObject json=new JSONObject(jsonStr);
                if(!json.isNull("datos")) {

                    jsonDatos = json.getJSONArray("datos");
                    for (int i = 0; i < jsonDatos.length(); i++) {
                        JSONObject jsonObject = jsonDatos.getJSONObject(i);
                        dato = new Datos(jsonObject.getString("nombre"),
                                jsonObject.getString("apellido"),
                                jsonObject.getString("telefono"));
                    }
                }else{
                    Log.d("Json:","Vacio");
                }
                //duracion de la ventana 3000 milisegundos
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }
        //accion previa
        protected void onPreExecute() {
            nDialog.show();
            nDialog.setContentView(R.layout.dialogo_grabando);


        }
        //accion posterior
        protected void onPostExecute(String result) {
            super.onPostExecute(result);

            if (nDialog.isShowing()) {
                nDialog.dismiss();
                mostrarDatoRemoto(dato);

            }
        }

    }
    private class TareaModificarWeb extends AsyncTask<Void, Void, String> {
        String URL = "http://"+Parametros.servidor+"/EjemploMysql/Modificar.php";
        // private JSONArray jsonDatos = null;
        ArrayList<String> valores;

        private ProgressDialog nDialog;
        public TareaModificarWeb(ArrayList<String> valores){
            nDialog = new ProgressDialog(getActivity());
            this.valores=valores;
        }
        @Override
        //accion principal
        protected String doInBackground(Void... voids) {

            ArrayList<String> keys = new ArrayList();
            ArrayList<String> valor = new ArrayList();
            keys.add(0, "nombre");valor.add(0, valores.get(0));
            keys.add(1, "apellido");valor.add(1, valores.get(1));
            keys.add(2, "telefono");valor.add(2, valores.get(2));
            keys.add(3, "nombreModificar");valor.add(3, valores.get(3));
            keys.add(4, "telefonoModificar");valor.add(4, valores.get(4));
            ConexionWeb conexionWeb = new ConexionWeb();
            conexionWeb.grabarDatos(URL, conexionWeb.armarGET(keys, valor));
            try {
                //duracion de la ventana 3000 milisegundos
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            return null;
        }
        //accion previa
        protected void onPreExecute() {
            nDialog.show();
            nDialog.setContentView(R.layout.dialogo_grabando);


        }
        //accion posterior
        protected void onPostExecute(String result) {
            super.onPostExecute(result);

            if (nDialog.isShowing()) {
                nDialog.dismiss();
                cancelar();
            }
        }

    }
}
